﻿
Imports System.Runtime.InteropServices

Public Class VbTest

    <DllImport("code05_03.dll", EntryPoint:="venc_b64")> _
    Private Shared Function code05_03(ByVal lpIn As IntPtr, ByVal dwSizeIn As Integer, ByVal lpOut As IntPtr) As Integer
    End Function

    <DllImport("code05_04.dll", EntryPoint:="venc_b64")> _
    Private Shared Function code05_04(ByVal lpIn As IntPtr, ByVal dwSizeIn As Integer, ByVal lpOut As IntPtr) As Integer
    End Function

    Friend Shared Sub Main()

        ' a 24MB input byte buffer
        Dim bIn((1024 * 1024 * 24) - 1) As Byte
        ' a 32MB output byte buffer
        Dim bOut((bIn.Length / 3 * 4) - 1) As Byte
        ' a 32MB output char buffer
        Dim cOut((bIn.Length / 3 * 4) - 1) As Char

        'Dim pIn As IntPtr = Marshal.AllocHGlobal(bIn.Length)
        'Dim pOut As IntPtr = Marshal.AllocHGlobal(bOut.Length)
        Dim gchIn As GCHandle = GCHandle.Alloc(bIn, GCHandleType.Pinned)
        Dim gchOut As GCHandle = GCHandle.Alloc(bOut, GCHandleType.Pinned)
        Dim pIn As IntPtr = gchIn.AddrOfPinnedObject()
        Dim pout As IntPtr = gchOut.AddrOfPinnedObject()

        Dim i As Integer

        Dim tc As Integer
        tc = Environment.TickCount
        Console.WriteLine(Environment.TickCount - tc)

        Console.WriteLine(".Net encoding")
        tc = Environment.TickCount
        For i = 0 To 10
            Convert.ToBase64CharArray(bIn, 0, bIn.Length, cOut, 0)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

        Console.WriteLine(".Net encoding")
        tc = Environment.TickCount
        For i = 0 To 10
            Convert.ToBase64CharArray(bIn, 0, bIn.Length, cOut, 0)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

        Console.WriteLine("code05_03")
        tc = Environment.TickCount
        For i = 0 To 10
            code05_03(pIn, bIn.Length, pout)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

        Console.WriteLine("code05_03")
        tc = Environment.TickCount
        For i = 0 To 10
            code05_03(pIn, bIn.Length, pout)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

        Console.WriteLine("code05_04")
        tc = Environment.TickCount
        For i = 0 To 10
            code05_04(pIn, bIn.Length, pout)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

        Console.WriteLine("code05_04")
        tc = Environment.TickCount
        For i = 0 To 10
            code05_04(pIn, bIn.Length, pout)
        Next
        Console.WriteLine(Environment.TickCount - tc)
        Console.WriteLine()

#If VBNOREADKEY Then
        Console.WriteLine("Press enter to close the window...")
    	Console.ReadLine()
#Else
        Console.WriteLine("Press any key to close the window...")
        Console.ReadKey()
#EndIf

    End Sub

End Class
